﻿//Based on Atom_look_at_camera.cs script by VRAdultFun, modified by Spacedog
//Apply plugin to an atom and it will rotate to face the camera. Untick Constrain to Y axis to allow X axis rotation

using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace MVRPlugin {
	public class Template : MVRScript {

		public Atom objectAtom;
		public FreeControllerV3 objectControl;
		
		public override void Init() {
			try {
				constrainToY = new JSONStorableBool("Constrain to Y axis", true);
                constrainToY.storeType = JSONStorableParam.StoreType.Full;
                RegisterBool(constrainToY);
                CreateToggle(constrainToY, false);
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		void Start() {
			try {
				objectAtom = containingAtom;
				objectControl = objectAtom.GetStorableByID("control") as FreeControllerV3;
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		void Update() {
			try {

					Vector3 lookPos = CameraTarget.centerTarget.transform.position - objectControl.transform.position;
					Quaternion lookRot = Quaternion.LookRotation(lookPos, Vector3.up);
					float eulerX = 0;
					if (constrainToY.val == false)
					{
						eulerX = lookRot.eulerAngles.x;
					}
					float eulerY = lookRot.eulerAngles.y;
					Quaternion rotation = Quaternion.Euler (eulerX, eulerY, 0);
					objectControl.transform.rotation = rotation;

			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		void FixedUpdate() {
			try {
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}
		protected JSONStorableBool constrainToY;
		void OnDestroy() {
		}

	}
}